function [r1,r2]=hyper_em_annotations(F,p,d)

mu=-d/log2(exp(1)); %uniform distribution
n=size(F,1);
T=length(p);

r1=zeros(n,T);
r1(:,1)=.5*ones(n,1);
r2=r1;

for t=2:T
    r1(:,t)= F(:,end) + log(1-p(t)+realmin);
    r2(:,t)= mu + log(p(t)+realmin);
    C=logsumexp([r1(:,t) r2(:,t)],2);
    r1(:,t)= exp(r1(:,t)-C); 
    r2(:,t)= exp(r2(:,t)-C);
end